//omp_ndot_critical.c
#include <stdio.h>
#include "pca_utils.h"

double ndot_critical(int n, double *x, double *y)
{
  double tot=0;
  #pragma omp parallel shared(x,y,n,tot) 
  {
    #pragma omp for
    for (int i=0; i<n; i++)
      #pragma omp critical
      tot += x[i] * y[i];
  }
  return tot;
}

int main(int argc, char *argv[]) {
  int n=1e7;
  double *x = vector(n);
  double *y = vector(n);
  for (int i=0; i<n; i++) {
    x[i] = i;
    y[i] = i;
  }
  double nn=n-1;
  double ans=nn*(nn+1)*(2*nn+1)/6.0;
  pca_time tt;
  tick(&tt);
  double dot=ndot_critical(n,x,y);
  printf("Dot product is %14.4e (vs %14.4e) for n=%d.\n"
         "Took %12.4e seconds.\n", 
	 dot, ans, n, tocksilent(&tt));
  return 0;
}
